package xyz.lychee.lagfixer.modules;

import com.google.common.collect.ImmutableList;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.EntityType;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockExplodeEvent;
import org.bukkit.event.entity.EntityChangeBlockEvent;
import xyz.lychee.lagfixer.LagFixer;
import xyz.lychee.lagfixer.managers.ModuleManager;
import xyz.lychee.lagfixer.objects.AbstractModule;
import xyz.lychee.lagfixer.objects.AbstractModule.Impact;

public class FpsHelperModule extends AbstractModule implements Listener, Runnable {
   public FpsHelperModule(LagFixer plugin, ModuleManager manager) {
      super(plugin, manager, Impact.LOW, "FpsHelper", ImmutableList.of("soon"), "eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvZWRjMzZjOWNiNTBhNTI3YWE1NTYwN2EwZGY3MTg1YWQyMGFhYmFhOTAzZThkOWFiZmM3ODI2MDcwNTU0MGRlZiJ9fX0=");
   }

   @EventHandler
   public void onExplode(BlockExplodeEvent e) {
      e.setCancelled(true);
      this.getPlugin().getLogger().info(e.blockList().toString());
   }

   @EventHandler
   public void onFallBlock(EntityChangeBlockEvent e) {
      if (e.getEntityType() == EntityType.FALLING_BLOCK) {
         Material m = e.getBlock().getType();
         e.setCancelled(true);
         Location loc = e.getBlock().getLocation();
         e.getBlock().setType(Material.AIR);

         Block block;
         do {
            do {
               block = loc.add(0.0, -1.0, 0.0).getBlock();
            } while(block.getType().equals(Material.AIR));
         } while(block.isLiquid());

         loc.add(0.0, 1.0, 0.0).getBlock().setType(m);
      }

   }

   public void run() {
   }

   public void load() {
      this.getPlugin().getServer().getPluginManager().registerEvents(this, this.getPlugin());
   }

   public boolean loadConfig() {
      return true;
   }

   public void disable() {
   }

   public abstract static class NMS {
      private final CustomTrackerModule module;

      public NMS(CustomTrackerModule module) {
         this.module = module;
      }

      public CustomTrackerModule getModule() {
         return this.module;
      }
   }
}
